=== debian/changelog ===
vtk-dicom (0.7.4-2) unstable; urgency=medium

  * [7273f4] d/control: Set minimum libvtk6-dev version 
    (needed for tests)

 -- Gert Wollny <gw.fossdev@gmail.com>  Sat, 20 Feb 2016 00:15:02 +0000

vtk-dicom (0.7.4-1) unstable; urgency=medium

  * New upstream release 
  * d/control: Add libvtk6-qt-dev to dependencies 
  * d/control: Update Standards version to 3.9.7 
  * d/control: Add xauth and xvfb to depends as they are needed for the 
    TCL test
  * d/p/: Add patch reproducable_build_datetime.patch to fix time 
    stamps in vtkDICOMBuild.h 
  * d/libvtk-dicom-dev.install, d/libvtkdicom0.7.install:
    Correct install path of cmake files to become arch dependnd 
    Closes: #813305

 -- Gert Wollny <gw.fossdev@gmail.com>  Fri, 19 Feb 2016 14:09:31 +0000

vtk-dicom (0.7.1-1) unstable; urgency=medium

  * New upstream version 
  * build by using vtk6 Closes: #803595 
  * Disable java bindings since these would require vtk java bindings 
  * Add patch 01_ to properly link required vtkIO*SQL libraries  
  * Move package to git 
  * Update standards version to 3.9.6 
  * Add python-vtk-dicom.lintian-override for package name  doesn't 
    match soname 
  * Override the VTK_VERSION_SUFFIX to avoid that the library changes 
    its name based on VTK minor version change. 
  * Add dh-python to build-deps as recommended 

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 03 Dec 2015 10:33:36 +0100
