=== debian/control ===
Source: vtk-dicom
Section: graphics
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>, 
           Gert Wollny <gw.fossdev@gmail.com> 
Build-Depends: cmake (>= 2.6.3),
               debhelper (>= 9),
               dh-python,
               help2man,
               libgdcm2-dev,
               libvtk6-dev (>= 6.2.0+dfsg1-9),
               libvtk6-qt-dev,
               python-all-dev,
               python-vtk6,
	       xvfb,
	       xauth  
Homepage: http://github.com/dgobbi/vtk-dicom/
Vcs-Browser:  https://anonscm.debian.org/cgit/debian-med/vtk-dicom.git
Vcs-Git: git://anonscm.debian.org/debian-med/vtk-dicom.git
Standards-Version: 3.9.7
X-Python-Version: 2.7

Package: libvtk-dicom-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libvtkdicom0.7 (= ${binary:Version}), ${misc:Depends}
Replaces: libvtk-dicom0.5-dev
Conflicts: libvtk-dicom0.5-dev
Description: DICOM for VTK - dev
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Development headers

Package: libvtkdicom0.7
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: DICOM for VTK - lib
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Libraries for runtime applications

Package: vtk-dicom-tools
Section: utils
Architecture: any
Depends: ${misc:Depends},  ${shlibs:Depends}
Description: DICOM for VTK - tools
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Command line tools

#Package: libvtk-dicom-java
#Section: java
#Architecture: any
#Depends: ${java:Depends}, ${misc:Depends}, ${shlibs:Depends}
#Suggests: java-virtual-machine
#Description: DICOM for VTK - java
# This package contains a set of classes for managing DICOM
# files and metadata from within VTK, and some utility programs
# for interrogating and converting DICOM files.
# .
# Java 1.5 bindings

Package: python-vtk-dicom
Section: python
Architecture: any
Depends: ${misc:Depends}, 
         ${python:Depends}, 
         ${shlibs:Depends}
Provides: ${python:Provides}
Description: DICOM for VTK - Python
 This package contains a set of classes for managing DICOM
 files and metadata from within VTK, and some utility programs
 for interrogating and converting DICOM files.
 .
 Python 2.x bindings
