## vtk-dicom 0.7.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 # Project version
 set(DICOM_MAJOR_VERSION 0)
 set(DICOM_MINOR_VERSION 7)
-set(DICOM_PATCH_VERSION 4)
+set(DICOM_PATCH_VERSION 8)
 set(DICOM_SHORT_VERSION "${DICOM_MAJOR_VERSION}.${DICOM_MINOR_VERSION}")
 set(DICOM_VERSION "${DICOM_SHORT_VERSION}.${DICOM_PATCH_VERSION}")
 
@@ -55,9 +55,9 @@
   option(BUILD_SHARED_LIBS "Build shared libraries." OFF)
 
   # Which parts of the package to build
-  option(BUILD_TESTING "Build the tests" ON)
+  option(BUILD_TESTING "Build the tests" OFF)
   option(BUILD_PROGRAMS "Build some useful DICOM tools" ON)
-  option(BUILD_EXAMPLES "Build the examples" ON)
+  option(BUILD_EXAMPLES "Build the examples" OFF)
 
   find_package(VTK REQUIRED)
   message(STATUS "vtkDICOM: Building vtkDICOM stand-alone")
