=== debian/changelog ===
vtk-dicom (0.7.8-1) unstable; urgency=medium

  * Imported Upstream version 0.7.8
  * d/p/01 update patch
  * d/control: Add -Wl,-z,now
  * d/control: correct git URL to secure version

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 31 May 2016 13:44:03 +0000

vtk-dicom (0.7.7-2) unstable; urgency=medium

  * d/p/repro...patch: Change date used to use non-locale month

 -- Gert Wollny <gw.fossdev@gmail.com>  Mon, 23 May 2016 12:08:25 +0000

vtk-dicom (0.7.7-1) unstable; urgency=medium

  * New upstream version
  * Update standards version to 3.9.8 

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 05 May 2016 16:20:17 +0000

vtk-dicom (0.7.6-1) unstable; urgency=medium

  * New upstream version

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 31 Mar 2016 21:38:35 +0000
