## vtk-dicom 0.7.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 # Project version
 set(DICOM_MAJOR_VERSION 0)
 set(DICOM_MINOR_VERSION 7)
-set(DICOM_PATCH_VERSION 8)
+set(DICOM_PATCH_VERSION 10)
 set(DICOM_SHORT_VERSION "${DICOM_MAJOR_VERSION}.${DICOM_MINOR_VERSION}")
 set(DICOM_VERSION "${DICOM_SHORT_VERSION}.${DICOM_PATCH_VERSION}")
 
@@ -250,6 +250,11 @@
     if(TMP_INDEX GREATER -1)
       set(VTK_LIBS ${VTK_LIBS} vtkIOMPIImage)
     endif()
+    # If vtkIOMySQL is present, it has factories for vtkIOSQL
+    list(FIND VTK_LIBRARIES vtkIOMySQL TMP_INDEX)
+    if(TMP_INDEX GREATER -1)
+      set(VTK_LIBS ${VTK_LIBS} vtkIOMySQL)
+    endif()
   else()
     set(VTK_LIBS vtkCommon vtkFiltering vtkImaging vtkIO vtkInfovis) # VTK 5.x
   endif()
@@ -363,7 +368,3 @@
 
   # Install the DICOMConfig.cmake and DICOMConfigVersion.cmake
   install(FILES
-    "${DICOM_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/DICOMConfig.cmake"
-    "${DICOM_BINARY_DIR}/DICOMConfigVersion.cmake"
-    DESTINATION "${DICOM_CMAKE_INSTALL_DEST}" COMPONENT Development)
-
