=== DicomCli/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
   ${MAINMACRO_SRC}
   readquery.cxx
   progress.cxx
+  vtkConsoleOutputWindow.cxx
 )
 
 add_library(${LIB_NAME} STATIC ${LIB_SRCS})
