=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -62,6 +62,7 @@
   vtkDICOMToRAS.cxx
   vtkDICOMCTRectifier.cxx
   vtkDICOMMetaDataAdapter.cxx
+  vtkDICOMUIDGenerator.cxx
   vtkNIFTIHeader.cxx
   vtkNIFTIReader.cxx
   vtkNIFTIWriter.cxx
@@ -268,9 +269,17 @@
   set_target_properties(${LIB_TCL_NAME} PROPERTIES
     OUTPUT_NAME ${LIB_TCL_OUTPUT_NAME})
   # create the pkgIndex.tcl file
-  set(MODULE_TCL_PATH ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
-  configure_file(${DICOM_CMAKE_DIR}/pkgIndex.tcl.in
-    "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgIndex.tcl" @ONLY)
+  if(CMAKE_CONFIGURATION_TYPES)
+    foreach(config ${CMAKE_CONFIGURATION_TYPES})
+      set(MODULE_TCL_PATH "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${config}")
+      configure_file(${DICOM_CMAKE_DIR}/pkgIndex.tcl.in
+        "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${config}/pkgIndex.tcl" @ONLY)
+    endforeach()
+  else()
+    set(MODULE_TCL_PATH ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
+    configure_file(${DICOM_CMAKE_DIR}/pkgIndex.tcl.in
+      "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgIndex.tcl" @ONLY)
+  endif()
   set(MODULE_TCL_PATH ${DICOM_LIBRARY_INSTALL_DEST})
   configure_file(${DICOM_CMAKE_DIR}/pkgIndex.tcl.in
     "${CMAKE_CURRENT_BINARY_DIR}/pkgIndex.tcl" @ONLY)
@@ -349,13 +358,3 @@
   ${LIB_NAME} ${LIB_PYTHON_NAME} ${MODULE_PYTHON_NAME}
     ${LIB_TCL_NAME} ${LIB_JAVA_NAME}
   EXPORT DICOMTargets
-  RUNTIME DESTINATION ${DICOM_RUNTIME_INSTALL_DEST} COMPONENT RuntimeLibraries
-  LIBRARY DESTINATION ${DICOM_LIBRARY_INSTALL_DEST} COMPONENT RuntimeLibraries
-  ARCHIVE DESTINATION ${DICOM_ARCHIVE_INSTALL_DEST} COMPONENT Development)
-
-if(BUILD_TCL_WRAPPERS)
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pkgIndex.tcl
-    DESTINATION ${DICOM_TCL_INSTALL_DEST})
-endif()
-
-if(BUILD_JAVA_WRAPPERS)
