=== Testing/CMakeLists.txt ===
--- 
+++ 
@@ -73,19 +73,24 @@
 endif()
 
 if(BUILD_TCL_WRAPPERS)
-  if(NOT VTK_TCL_EXE AND (NOT UNIX OR DEFINED ENV{DISPLAY}))
-    get_target_property(WRAP_TCL_PATH vtkWrapTcl LOCATION_<CONFIG>)
-    get_filename_component(VTK_EXE_DIR ${WRAP_TCL_PATH} PATH)
-    find_program(VTK_TCL_EXE vtk "${VTK_EXE_DIR}")
+  if(CMAKE_CONFIGURATION_TYPES)
+    if(NOT VTK_TCL_EXE)
+      get_target_property(WRAP_TCL_PATH vtkWrapTcl LOCATION_<CONFIG>)
+      get_filename_component(VTK_EXE_DIR ${WRAP_TCL_PATH} PATH)
+      find_program(VTK_TCL_EXE vtk "${VTK_EXE_DIR}")
+    endif()
+    if(NOT VTK_TCL_EXE)
+      # fall back to using tclsh
+      set(VTK_TCL_EXE ${TCL_TCLSH})
+    endif()
+    add_test(TestDICOMTcl "${VTK_TCL_EXE}"
+      "${CMAKE_CURRENT_SOURCE_DIR}/TestDICOMTcl.tcl")
+  else()
+    add_test(TestDICOMTcl "${TCL_TCLSH}"
+      "${CMAKE_CURRENT_SOURCE_DIR}/TestDICOMTcl.tcl")
+    set_tests_properties(TestDICOMTcl PROPERTIES ENVIRONMENT
+      "TCLLIBPATH={${VTK_DIR}/Wrapping/Tcl} {${CMAKE_LIBRARY_OUTPUT_DIRECTORY}}")
   endif()
-  if(NOT VTK_TCL_EXE)
-    # fall back to using tclsh
-    set(VTK_TCL_EXE ${TCL_TCLSH})
-  endif()
-  add_test(TestDICOMTcl "${TCL_TCLSH}"
-    "${CMAKE_CURRENT_SOURCE_DIR}/TestDICOMTcl.tcl")
-  set_tests_properties(TestDICOMTcl PROPERTIES ENVIRONMENT
-    "TCLLIBPATH={${CMAKE_LIBRARY_OUTPUT_DIRECTORY}} {${VTK_DIR}/Wrapping/Tcl}")
 endif()
 
 if(BUILD_JAVA_WRAPPERS)
