=== debian/changelog ===
vtk-dicom (0.7.10-1) unstable; urgency=medium

  * New upstream version 0.7.10

 -- Gert Wollny <gw.fossdev@gmail.com>  Sat, 01 Oct 2016 21:01:42 +0200
