=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>, 
            Gert Wollny <gw.fossdev@gmail.com> 
-Build-Depends: cmake (>= 2.6.3),
+Build-Depends: cmake,
                debhelper (>= 9),
                dh-python,
                help2man,
@@ -14,11 +14,11 @@
                python-all-dev,
                python-vtk6,
 	       xvfb,
-	       xauth  
+	       xauth
 Homepage: http://github.com/dgobbi/vtk-dicom/
-Vcs-Browser:  https://anonscm.debian.org/cgit/debian-med/vtk-dicom.git
-Vcs-Git: git://anonscm.debian.org/debian-med/vtk-dicom.git
-Standards-Version: 3.9.7
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/vtk-dicom.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/vtk-dicom.git
+Standards-Version: 3.9.8
 X-Python-Version: 2.7
 
 Package: libvtk-dicom-dev
